unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.Buttons, ShlObj, ActiveX;

type
  TMainForm = class(TForm)
    ButtonGenerate: TButton;
    EditPassword: TLabeledEdit;
    EditCountryCode: TLabeledEdit;
    EditCountryName: TLabeledEdit;
    EditCity: TLabeledEdit;
    EditCompanyName: TLabeledEdit;
    EditCN: TLabeledEdit;
    ButtonBrowse: TSpeedButton;
    {$WARNINGS OFF}
    FoldersOpenDialog: TFileOpenDialog;
    EditDirectory: TLabeledEdit;
    {$WARNINGS ON}
    procedure ButtonGenerateClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonBrowseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

function GetSystemPath(Folder: Integer): string;
var
  PIDL: PItemIDList;
  Path: PChar;
  AMalloc: IMalloc;
begin
  Path := StrAlloc(MAX_PATH);
  SHGetSpecialFolderLocation(Application.Handle, Folder, PIDL);
  if SHGetPathFromIDList(PIDL, Path) then Result := Path;
  SHGetMalloc(AMalloc);
  AMalloc.Free(PIDL);
  StrDispose(Path);
end;

function GenerateCertificates(const OpenSSLPath: string; Password: string; const CountryCode: string; const CountryName: string; const City: string; const Organization: string; const CN: string; const Directory: string): boolean;
var
  startUpInfo: TStartUpInfo;
  ProcInfo: TProcessInformation;
  Command: string;
  OrganizationReplaced, CNReplaced, SignFull, Sign: String;
  SignTextFull, SignText: TStringList;
  i, p, l, s: Integer;
begin
  Result := false;
  ForceDirectories(Directory);
  FillChar(startUpInfo, SizeOf(TStartUpInfo), 0);
  Command := '"'+OpenSSLPath+'\openssl.exe" genrsa -aes256 -out private.key -passout pass:'+Password+' 2048';
  if (CreateProcess(Pchar(OpenSSLPath+'\openssl.exe'), PChar(Command), nil, nil, true, NORMAL_PRIORITY_CLASS, nil, PChar(Directory), StartupInfo, ProcInfo)) then
    begin
      while WaitForSingleObject(ProcInfo.hProcess, 10) > 0 do
      Application.ProcessMessages;
      OrganizationReplaced := StringReplace(Organization, '/', '\/', [rfReplaceAll, rfIgnoreCase]);
      CNReplaced := StringReplace(CN, '/', '\/', [rfReplaceAll, rfIgnoreCase]);
      Command := '"'+OpenSSLPath+'\openssl.exe" req -config "'+OpenSSLPath+'\openssl.cfg" -new -key private.key -out request.csr -subj "/C='+CountryCode+'/ST='+CountryName+'/L='+City+'/O='+OrganizationReplaced+'/OU=/CN='+CNReplaced+'" -passin pass:'+Password;
      if (CreateProcess(Pchar(OpenSSLPath+'\openssl.exe'), PChar(Command), nil, nil, true, NORMAL_PRIORITY_CLASS, nil, PChar(Directory), StartupInfo, ProcInfo)) then
        begin
          while WaitForSingleObject(ProcInfo.hProcess, 10) > 0 do
            Application.ProcessMessages;
            SignFull := Directory+'\sign_full.txt';
            Sign := Directory+'\sign.txt';
            Command := '"'+OpenSSLPath+'\openssl.exe" req -config "'+OpenSSLPath+'\openssl.cfg" -in request.csr -noout -text -out "'+SignFull+'"';
            if (CreateProcess(Pchar(OpenSSLPath+'\openssl.exe'), PChar(Command), nil, nil, true, NORMAL_PRIORITY_CLASS, nil, PChar(Directory), StartupInfo, ProcInfo)) then
              begin
              while WaitForSingleObject(ProcInfo.hProcess, 10) > 0 do
                Application.ProcessMessages;
              end;
              SignTextFull := TStringList.Create;
              SignTextFull.LoadFromFile(SignFull);
              l := 0;
              for i := 0 to SignTextFull.Count-1 do
                begin
                  p := Pos('Signature Algorithm', SignTextFull[i].Trim);
                  if (p>0) then
                    begin
                      l := i+1;
                      break;
                    end;
                end;
              if(l>0) then
                SignText := TStringList.Create;
                begin
                  for i := l to SignTextFull.Count-1 do
                    SignText.Add(SignTextFull[i].trim);
                end;
                if(SignText.Count>0) then
                  SignText.SaveToFile(Directory + '\sign.txt');
              Result := true;
        end;
      CloseHandle(ProcInfo.hProcess);
      CloseHandle(ProcInfo.hThread);
    end;

end;

{$WARNINGS OFF}
procedure TMainForm.ButtonBrowseClick(Sender: TObject);
begin
  if(FoldersOpenDialog.Execute) then
    EditDirectory.Text := FoldersOpenDialog.FileName;
end;
{$WARNINGS ON}

procedure TMainForm.ButtonGenerateClick(Sender: TObject);
var
  AppDir: string;
  OpenSSLPath: string;
begin
  AppDir := ExtractFilePath(Application.ExeName);
  OpenSSLPath := AppDir + 'openssl';
  if(FileExists(OpenSSLPath+'\openssl.exe')) then
    begin
      GenerateCertificates(OpenSSLPath, EditPassword.Text,EditCountryCode.Text,EditCountryName.Text,EditCity.Text,EditCompanyName.Text,EditCN.Text,EditDirectory.Text);
    end
    else
    begin
      ShowMessage('OpenSSL not found!');
    end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  Dir: string;
begin
  Dir := GetSystemPath(CSIDL_DESKTOPDIRECTORY);
  if(Dir[Length(Dir)]<>'\') then
    Dir := Dir + '\';
  Dir := Dir + 'certificate';
  EditDirectory.Text := Dir;
end;

end.
